Index: trunk/src/lib/gui/gl/glgui_widget.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_widget.h	(revision 8527)
+++ trunk/src/lib/gui/gl/glgui_widget.h	(revision 8619)
@@ -9,5 +9,6 @@
 #include "element_2d.h"
 
-#include "glgui_style.h"
+#include "glgui_defs.h"
+
 #include "material.h"
 #include "rect2D.h"
@@ -15,4 +16,6 @@
 #include "event.h"
 #include "signal_connector.h"
+
+class Font;
 
 namespace OrxGui
@@ -66,35 +69,138 @@
     void disconnect(GLGuiWidget* sender, Signal& signal, BaseObject* receiver);
 
-
-    GLGuiStyle& style() { return this->_style; };
-    const GLGuiStyle style() const { return this->_style; };
-
-    /// MATERIAL (looks)
-    Material& backMaterial() { return this->_backMat; };
-    const Material& backMaterial() const { return this->_backMat; };
+    OrxGui::State state() const { return this->_state; };
+
     Rect2D& backRect() { return this->_backRect; };
     const Rect2D& backRect() const { return this->_backRect; };
 
     void setFrontColor(const Color& frontColor, bool instantaniously = false);
-    const Color& frontColor() const { return this->_frontColor; };
-
-    /** @brief sets all borders to the same value. */
-    void setBorderSize(float borderSize);
-    void setBorderLeft(float borderLeft);
-    void setBorderRight(float borderRight);
-    void setBorderTop(float borderTop);
-    void setBorderBottom(float borderBottom);
-
-    float borderLeft() const { return this->_borderLeft; };
-    float borderRight() const { return this->_borderRight; };
-    float borderTop() const { return this->_borderTop; };
-    float borderBottom() const { return this->_borderBottom; };
-
 
     void setWidgetSize(const Vector2D& size);
     void setWidgetSize(float x, float y);
 
-
-    void setBackgroundColor(float x, float y, float z) { this->backMaterial().setDiffuse(x,y,z); };
+    void animateBack();
+
+    /// STYLE
+    ////////////////////////////////
+    /// Retrieve Current Values. ///
+    ////////////////////////////////
+    /** @returns current left borderWidth */
+    inline float borderLeft() const { return _currentStyle._borderLeft; }
+    /** @returns current right borderWidth */
+    inline float borderRight() const { return _currentStyle._borderRight; }
+    /** @returns current top borderWidth */
+    inline float borderTop() const { return _currentStyle._borderTop; }
+    /** @returns burrent bottom borderWidth */
+    inline float borderBottom() const { return _currentStyle._borderBottom; }
+
+
+    /** @returns current textSize */
+    inline float textSize() const { return _currentStyle._textSize; }
+    /** @returns the Background Color */
+    inline const Color& backgroundColor() const { return _currentStyle._background.diffuseColor(); }
+    /** @returns the current Background Material. */
+    inline const Material& background() const { return _currentStyle._background; }
+    /** @returns the current background Texture. */
+    inline const Texture& backgroundTexture() const { return _currentStyle._background.diffuseTexture(); }
+    /** @returns the current foreground Color */
+    inline const Color& foregroundColor() const { return _currentStyle._foreground.diffuseColor(); }
+    /** @returns the current ForeGroung Material. */
+    inline const Material& foreground() const { return _currentStyle._foreground; }
+
+
+    /** @returns FeaturePosition */
+    inline FeaturePosition featurePosition() const { return _featurePosition; }
+    /** @returns the font */
+    inline const Font* const font() const { return _font; }
+    /** @returns true if the Element is Animated */
+    inline bool animating() const { return _animating; }
+    /** @returns true if State-Changes are animated */
+    inline bool animatedStateChanges() const { return _animatedStateChanges; }
+
+
+    ///////////////////////////////////////////////////////////////
+    /// Retrieve Values for the Saved Values inside the States. ///
+    ///////////////////////////////////////////////////////////////
+    /** @returns left borderWidth @param state the State to retrieve from */
+    inline float borderLeft(OrxGui::State state) const { return _style[state]._borderLeft; }
+    /** @returns right borderWidth @param state the State to retrieve from */
+    inline float borderRight(OrxGui::State state) const { return _style[state]._borderRight; }
+    /** @returns top borderWidth @param state the State to retrieve from */
+    inline float borderTop(OrxGui::State state) const { return _style[state]._borderTop; }
+    /** @returns bottom borderWidth @param state the State to retrieve from */
+    inline float borderBottom(OrxGui::State state) const { return _style[state]._borderBottom; }
+
+    /** @returns textSize @param state the State to retrieve from */
+    inline float textSize(OrxGui::State state) const { return _style[state]._textSize; }
+    /** @returns the Background Color @param state the State to retrieve from */
+    inline const Color& backgroundColor(OrxGui::State state) const { return _style[state]._background.diffuseColor(); }
+    /** @returns the Background Material. @param state the state to retrieve from */
+    inline const Material& background(OrxGui::State state) const { return _style[state]._background; }
+    /** @returns background Texture. @param state the State to retrieve from */
+    inline const Texture& backgroundTexture(OrxGui::State state) const { return _style[state]._background.diffuseTexture(); }
+    /** @returns the foreground Color @param state the State to retrieve from */
+    inline const Color& foregroundColor(OrxGui::State state) const { return _style[state]._foreground.diffuseColor(); }
+    /** @returns the ForeGroung Material. @param state the state to retrieve from */
+    inline const Material& foreground(OrxGui::State state) const { return _style[state]._foreground; }
+
+
+    /// SETUP
+    void resetStyle();
+    void loadParams(const TiXmlElement* root);
+
+    void setBorderLeft(float value);
+    void setBorderLeft(float value, OrxGui::State state);
+    void setBorderLeftS(float value, const std::string& stateName);
+
+    void setBorderRight(float value);
+    void setBorderRight(float value, OrxGui::State state);
+    void setBorderRightS(float value, const std::string& stateName);
+
+    void setBorderTop(float value);
+    void setBorderTop(float value, OrxGui::State state);
+    void setBorderTopS(float value, const std::string& stateName);
+
+    void setBorderBottom(float value);
+    void setBorderBottom(float value, OrxGui::State state);
+    void setBorderBottomS(float value, const std::string& stateName);
+
+    void setTextSize(float value);
+    void setTextSize(float value, OrxGui::State state);
+    void setTextSizeS(float value, const std::string& stateName);
+
+    void setBackgroundColor(const Color& color);
+    void setBackgroundColor(const Color& color, OrxGui::State state);
+    void setBackgroundColorS(float r, float g, float b, float a, const std::string& stateName);
+
+    void setBackgroundTexture(const Texture& texture);
+    void setBackgroundTexture(const std::string& textureName);
+    void setBackgroundTexture(const Texture& texture, OrxGui::State state);
+    void setBackgroundTexture(const std::string& textureName, const std::string& stateName);
+
+    void setForegroundColor(const Color& color);
+    void setForegroundColor(const Color& color, OrxGui::State state);
+    void setForegroundColorS(float r, float g, float b, float a, const std::string& stateName);
+
+    void loadBackgroundMaterial(const Material& material);
+    void loadBackgroundMaterial(const Material& material, OrxGui::State state);
+    void loadBackgroundMaterial(const TiXmlElement* element);
+    void loadBackgroundMaterial(const TiXmlElement* element, OrxGui::State state);
+    void loadBackgroundMaterialS(const TiXmlElement* element, const std::string& stateName);
+
+    void loadForegroundMaterial(const Material& material);
+    void loadForegroundMaterial(const Material& material, OrxGui::State state);
+    void loadForegroundMaterial(const TiXmlElement* element, OrxGui::State state);
+    void loadForegroundMaterialS(const TiXmlElement* element, const std::string& stateName);
+
+    void setFeaturePosition(FeaturePosition featurePosition);
+    void setFeaturePositionS(const std::string& featurePosition);
+
+    void setFont(Font* font);
+    void setFont(const std::string& fontName);
+
+    void setAnimatedStateChanges(bool animated);
+    void switchState(OrxGui::State state);
+
+
 
     inline void drawRect(const Rect2D& rect) const
@@ -116,4 +222,5 @@
     virtual bool processEvent(const Event& event) { return false; };
 
+    bool getState(const std::string& stateName, OrxGui::State* state);
 
   protected:
@@ -137,27 +244,26 @@
     virtual void destroyed();
 
+    virtual void debug() const;
+
   private:
     void init();
 
   private:
+    static GLGuiWidget*            _selected;         //!< The currently selected Widget.
+    static GLGuiWidget*            _focused;          //!< The currently Focused Widget.
+    static GLGuiWidget*            _inputGrabber;     //!< The Widget that grabs input.
+
+
+    /// WIDGET
     GLGuiWidget*                   _parent;           //!< The parent of this Widget.
 
     /// LOOKS
-    Material                       _backMat;
     Rect2D                         _backRect;
-
-    Color                          _frontColor;
-    Color*                         _toFrontColor;
-
-    float                          _borderLeft;
-    float                          _borderRight;
-    float                          _borderTop;
-    float                          _borderBottom;
-
     Vector2D                       _minSize;
 
-    GLGuiStyle                     _style;
 
     /// EVENTS
+    OrxGui::State                  _state;
+
     bool                           _focusable;        //!< If this widget can receive focus.
     bool                           _clickable;        //!< if this widget can be clicked upon.
@@ -166,8 +272,36 @@
 
 
-    static GLGuiWidget*            _selected;         //!< The currently selected Widget.
-    static GLGuiWidget*            _focused;          //!< The currently Focused Widget.
-
-    static GLGuiWidget*            _inputGrabber;     //!< The Widget that grabs input.
+
+    /// STYLE - Variables.
+    typedef struct
+    {
+      float             _borderLeft;           //!< The Distance to the left Border of the widget, before any internal Element starts.
+      float             _borderRight;          //!< The Distance to the right Border of the widget, before any internal Element starts.
+      float             _borderTop;            //!< The Distance to the top Border of the widget, before any internal Element starts
+      float             _borderBottom;         //!< The Distance to the bottom Border of the widget, before any internal Element starts
+
+      float             _textSize;             //!< The TextSize of the Widget.
+
+      Material          _background;           //!< The Background Material of the Widget.
+
+      Material          _foreground;           //!< The foreground Material of the Widget.
+    }
+    StatedStyle;
+
+
+    StatedStyle         _style[GLGUI_STATE_COUNT]; //!< Styles configured for different States
+
+    FeaturePosition     _featurePosition;      //!< The Position a Feature will be layed at (checkbox(box), slider(text),...)
+    Font*               _font;                 //!< The Font used in the current Widget.
+
+
+    /// ANIMATION STUFF:
+    bool                _animatedStateChanges; //!< If the Transitions between States are Animated automatically.
+
+    bool                _animating;            //!< If the Widget is animated at the moment (Texture might be an AnimatedTexture.)
+    float               _animationCycle;
+    float               _animationDuration;
+    StatedStyle         _currentStyle;
+
   };
 }
Index: trunk/src/lib/gui/gl/specials/glgui_notifier.cc
===================================================================
--- trunk/src/lib/gui/gl/specials/glgui_notifier.cc	(revision 8527)
+++ trunk/src/lib/gui/gl/specials/glgui_notifier.cc	(revision 8619)
@@ -25,5 +25,5 @@
 
   /**
-   * standard constructor
+   * @brief standard constructor
    */
   GLGuiNotifier::GLGuiNotifier ()
@@ -34,4 +34,6 @@
     this->lineSpacing = 0;
     this->linesProcessed = 0;
+    this->_fadeAge = 3.0;
+    this->setHideAge(4.0);
 
     this->setDisplayLineCount(10);
@@ -57,30 +59,45 @@
   }
 
+  /**
+   * @brief push a message onto the notifier.
+   * @param message the message to be pushed.
+   *
+   * @note it is not guaranteed, that the message is delivered instantaniously
+   * The possibility may arise, that the DisplayLines are all in use, then one
+   * has to wait until a line gets hidden, until a new one can be pushed to be
+   * displayed.
+   */
   void GLGuiNotifier::pushNotifyMessage(const std::string& message)
   {
     if (!this->hiddenText.empty())
     {
-      printf("%s\n", message.c_str());
-      DisplayLine dl;
+      DisplayLine dl; // put everything in here, and then display it
+
+      // retrieve a Text.
       dl.text = this->hiddenText.top();
-
+      this->hiddenText.pop();
+
+      // setup Text
       dl.text->setBlending(1.0f);
       dl.text->setText(message);
-      this->hiddenText.pop();
+      dl.text->setVisibility(true);
+      dl.text->setRelCoor2D(this->calculateLinePosition(0));
+
       dl.age = 0.0f;
       this->displayLines.push_front(dl);
-
-      dl.text->setVisibility(true);
-      dl.text->setRelCoor2D(this->calculateLinePosition(0));
       this->repositionText();
     }
     else
     {
+      // push it onto the List of messages we still need.
       this->inputBuffer.push_front(message);
-      //printf("grumble... must be fixed\n");
-    }
-  }
-
-
+    }
+  }
+
+
+  /**
+   * @brief sets the Dipsplay Line Count of the Notifier.
+   * @param coun the count of displayLines.
+   */
   void GLGuiNotifier::setDisplayLineCount(unsigned int count)
   {
@@ -96,4 +113,16 @@
   }
 
+  void GLGuiNotifier::setFadeAge(float fadeAge)
+  {
+    this->_fadeAge = fadeAge;
+    this->_transformAge = hideAge() - this->fadeAge();
+  }
+
+  void GLGuiNotifier::setHideAge(float hideAge)
+  {
+    this->_hideAge = hideAge;
+    this->_transformAge = this->hideAge() - fadeAge();
+  }
+
 
   /**
@@ -119,9 +148,9 @@
   void GLGuiNotifier::applyTextSettings(MultiLineText* text)
   {
-    text->setSize(this->style().textSize());
+    text->setSize(this->textSize());
     text->setLineWidth( 300 );
-    text->setFont("fonts/final_frontier.ttf", (int)this->style().textSize());
-
-    text->setColor(this->style().foregroundColor() );
+    text->setFont("fonts/final_frontier.ttf", (int)this->textSize());
+
+    text->setColor(this->foregroundColor() );
     if (text->getParent2D() != this)
       text->setParent2D(this);
@@ -129,4 +158,8 @@
 
 
+  /**
+   * @brief ticks the entire Notifier.
+   * @param dt the time passed since the last Tick
+   */
   void GLGuiNotifier::tick(float dt)
   {
@@ -135,8 +168,8 @@
     {
       (*line).age+=dt;
-      if ((*line).age > 3.0f)
+      if ((*line).age > this->fadeAge())
       {
-        (*line).text->setBlending(4.0 - (*line).age);
-        if ((*line).age > 4.0f)
+        (*line).text->setBlending((hideAge() - (*line).age)/_transformAge);
+        if ((*line).age > hideAge())
         {
           std::list<DisplayLine>::iterator tmp = line;
@@ -167,5 +200,5 @@
     this->beginDraw();
 
-    this->backMaterial().select();
+    this->background().select();
     this->drawRect(this->backRect());
     this->endDraw();
@@ -183,5 +216,5 @@
   Vector2D GLGuiNotifier::calculateLinePosition(unsigned int lineNumber)
   {
-    return Vector2D(0.0f, (float)(this->style().textSize() + this->lineSpacing)*(float)((int)this->bufferDisplaySize - (int)lineNumber - (int)1));
+    return Vector2D(0.0f, (float)(textSize() + this->lineSpacing)*(float)((int)this->bufferDisplaySize - (int)lineNumber - (int)1));
   }
 
Index: trunk/src/lib/gui/gl/specials/glgui_notifier.h
===================================================================
--- trunk/src/lib/gui/gl/specials/glgui_notifier.h	(revision 8527)
+++ trunk/src/lib/gui/gl/specials/glgui_notifier.h	(revision 8619)
@@ -30,6 +30,13 @@
     void pushNotifyMessage(const std::string& message);
 
-    // BUFFERS
+    /// Setup
     void setDisplayLineCount(unsigned int count);
+    void setFadeAge(float fadeAge);
+    void setHideAge(float hideAge);
+
+    /** @returns the beginning of the Hiding process */
+    inline float fadeAge() const { return _fadeAge; };
+    /** @returns at what age elements should be fully hidden */
+    inline float hideAge() const { return _hideAge; };
 
     void clear();
@@ -54,4 +61,5 @@
 
   private:
+    //! structure that defines a Displayed line.
     typedef struct
     {
@@ -59,6 +67,10 @@
       MultiLineText*    text;
 
-    }
-    DisplayLine;
+    } DisplayLine;
+
+
+    float                       _fadeAge;
+    float                       _hideAge;
+    float                       _transformAge;
 
     unsigned int                lineSpacing;            //!< The Spacing between lines.
@@ -72,5 +84,5 @@
 
     unsigned long               linesProcessed;         //!< How many Lines have been processed so far.
-    std::list<std::string>      inputBuffer;            //!<
+    std::list<std::string>      inputBuffer;            //!< The input buffer for lines that were not yet printet out, because there is too much input.
 
   };
Index: trunk/src/lib/math/rect2D.cc
===================================================================
--- trunk/src/lib/math/rect2D.cc	(revision 8527)
+++ trunk/src/lib/math/rect2D.cc	(revision 8619)
@@ -475,2 +475,9 @@
 }
 
+/**
+ * @brief print debug output for the Rect
+ */
+void Rect2D::debug() const
+{
+  PRINT(0)("Top: %0.2f Left: %0.2f; Bottom %0.2f Right:%0.2f; Size: %0.2fx%0.2f\n", top(), left(), bottom(), right(), size().x, size().y);
+}
Index: trunk/src/lib/math/rect2D.h
===================================================================
--- trunk/src/lib/math/rect2D.h	(revision 8527)
+++ trunk/src/lib/math/rect2D.h	(revision 8619)
@@ -127,4 +127,6 @@
   const Rect2D& slerp(const Rect2D& rect, float value);
 
+  void debug() const;
+
 private:
   Vector2D _topLeft;
Index: trunk/src/lib/sound/sound_buffer.cc
===================================================================
--- trunk/src/lib/sound/sound_buffer.cc	(revision 8527)
+++ trunk/src/lib/sound/sound_buffer.cc	(revision 8619)
@@ -114,5 +114,5 @@
     else if (stereo && !is16Bit)
       return AL_FORMAT_STEREO8;
-    else if (stereo && is16Bit)
+    else /* if (stereo && is16Bit) */
       return AL_FORMAT_STEREO16;
   }
Index: trunk/src/lib/util/executor/functor_list.h
===================================================================
--- trunk/src/lib/util/executor/functor_list.h	(revision 8527)
+++ trunk/src/lib/util/executor/functor_list.h	(revision 8619)
@@ -144,3 +144,5 @@
   FUNCTOR_LIST(3)(l_STRING, l_UINT, l_UINT);
 
+  FUNCTOR_LIST(5)(l_FLOAT, l_FLOAT, l_FLOAT, l_FLOAT, l_STRING);
+
 #endif /* FUNCTOR_LIST */
Index: trunk/src/lib/util/filesys/file.cc
===================================================================
--- trunk/src/lib/util/filesys/file.cc	(revision 8527)
+++ trunk/src/lib/util/filesys/file.cc	(revision 8619)
@@ -205,5 +205,5 @@
 
 /// FIXME NEXT THREE FUNCTIONS
-bool File::isReadeable() const
+bool File::isReadable() const
 {
 #ifndef __WIN32__
Index: trunk/src/lib/util/filesys/file.h
===================================================================
--- trunk/src/lib/util/filesys/file.h	(revision 8527)
+++ trunk/src/lib/util/filesys/file.h	(revision 8619)
@@ -51,5 +51,5 @@
   bool isFile() const;
   bool isDirectory() const;
-  bool isReadeable() const;
+  bool isReadable() const;
   bool isWriteable() const;
   bool isExecutable() const;
Index: trunk/src/story_entities/simple_game_menu.cc
===================================================================
--- trunk/src/story_entities/simple_game_menu.cc	(revision 8527)
+++ trunk/src/story_entities/simple_game_menu.cc	(revision 8619)
@@ -120,8 +120,18 @@
     OrxGui::GLGuiSlider* slider = new OrxGui::GLGuiSlider();
     slider->connect(SIGNAL(slider, valueChanged), this, SLOT(SimpleGameMenu, TEST));
-    slider->connect(SIGNAL(slider, valueChanged), box, SLOT(OrxGui::GLGuiWidget, setBackgroundColor));
     slider->setRange(0, 1);
     slider->setValue(slider->min());
     box->pack(slider);
+
+
+    OrxGui::GLGuiTable* table = new OrxGui::GLGuiTable(3, 3);
+    std::vector<std::string> headers;
+    headers.push_back("1");
+    headers.push_back("2");
+    headers.push_back("3");
+    table->setHeader(headers);
+
+
+    box->pack(table);
   }
   box->setAbsCoor2D(50, 200);
Index: trunk/src/util/hud.cc
===================================================================
--- trunk/src/util/hud.cc	(revision 8527)
+++ trunk/src/util/hud.cc	(revision 8619)
@@ -89,6 +89,5 @@
   {
     this->energyWidget->show();
-    this->energyWidget->backMaterial().setDiffuseMap("hud_energy_background.png");
-    this->energyWidget->backMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+    this->energyWidget->setBackgroundTexture( "hud_energy_background.png");
     /*    this->energyWidget->frontMaterial().setDiffuseMap("hud_energy_bar.png");
         this->energyWidget->frontMaterial().setBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);*/
@@ -143,6 +142,5 @@
       {
         weapon->getEnergyWidget()->show();
-        weapon->getEnergyWidget()->backMaterial().setDiffuse( .8,.2,.11);
-        weapon->getEnergyWidget()->backMaterial().setTransparency(.1);
+        weapon->getEnergyWidget()->setBackgroundColor(Color(.8,.2,.11, 0.1));
         weapon->getEnergyWidget()->setFrontColor(Color( .2,.5,.7,.6));
         //      weapon->getEnergyWidget()->frontMaterial().setTransparency(.6);
Index: trunk/src/world_entities/environments/mapped_water.cc
===================================================================
--- trunk/src/world_entities/environments/mapped_water.cc	(revision 8527)
+++ trunk/src/world_entities/environments/mapped_water.cc	(revision 8619)
@@ -80,5 +80,5 @@
   memset(pTextureReflection, 0, this->textureSize * this->textureSize * channels * sizeof(unsigned int));
   //mat.select();
-  glBindTexture(GL_TEXTURE_2D, this->mat.getDiffuseTexture(0));
+  glBindTexture(GL_TEXTURE_2D, this->mat.diffuseTextureID(0));
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
@@ -90,5 +90,5 @@
   unsigned int* pTextureRefraction = new unsigned int [this->textureSize * this->textureSize * channels];
   memset(pTextureRefraction, 0, this->textureSize * this->textureSize * channels * sizeof(unsigned int));
-  glBindTexture(GL_TEXTURE_2D, this->mat.getDiffuseTexture(1));
+  glBindTexture(GL_TEXTURE_2D, this->mat.diffuseTextureID(1));
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
@@ -281,5 +281,5 @@
   ///
 
-  glBindTexture(GL_TEXTURE_2D, this->mat.getDiffuseTexture(0));
+  glBindTexture(GL_TEXTURE_2D, this->mat.diffuseTextureID(0));
 
   // Create the texture and store it on the video card
@@ -351,5 +351,5 @@
   if(pos.y > waterHeight)
   {
-    double plane[4] = {0.0, -1.0, 0.0, waterHeight}; 
+    double plane[4] = {0.0, -1.0, 0.0, waterHeight};
     glClipPlane(GL_CLIP_PLANE0, plane);
 
@@ -359,5 +359,5 @@
   {
     glCullFace(GL_FRONT);
-    double plane[4] = {0.0, 1.0, 0.0, -waterHeight}; 
+    double plane[4] = {0.0, 1.0, 0.0, -waterHeight};
     glClipPlane(GL_CLIP_PLANE0, plane);
   }
@@ -370,5 +370,5 @@
 
 
-  glBindTexture(GL_TEXTURE_2D, this->mat.getDiffuseTexture(1));
+  glBindTexture(GL_TEXTURE_2D, this->mat.diffuseTextureID(1));
 
   // Create the texture and store it on the video card
Index: trunk/src/world_entities/skybox.h
===================================================================
--- trunk/src/world_entities/skybox.h	(revision 8527)
+++ trunk/src/world_entities/skybox.h	(revision 8619)
@@ -53,5 +53,5 @@
                            const std::string& posY, const std::string& negZ, const std::string& posZ);
 
-  GLuint getTexture(SKY_SIDE side) const { return (this->material[side]) ? this->material[side]->getDiffuseTexture(): 0; };
+  GLuint getTexture(SKY_SIDE side) const { return (this->material[side]) ? this->material[side]->diffuseTextureID(): 0; };
 
   static void enableCubeMap();
@@ -69,5 +69,5 @@
   float           textureSize;     //!< this is the length of a texture (assumes a square texture)
   std::string     textureName;     //!< Name of the Texture
-  
+
   int textureName_handle;          //!< used to notify about changes of textureName
   int size_handle;                 //!< used to notify about changes of size
